SystemOrganization addCategory: #'OMeta2-Exp'!

OMeta2 subclass: #LSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystem commentStamp: 'sn 9/14/2014 01:22' prior: 0!
"Koch snowflake"

|match|
match := 'F++F++F'.
1 to: 3 do:[:each|
	match := LSystem matchAll: match with: #start.
].	
"match inspect."
LSystem draw: match.!

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:13'!
draw: aString

	|pen sym lineLength angle|

	pen := Pen new.
	lineLength := 10.
	angle := 60.

	1 to: aString size do:[:each|
		sym := (aString at: each) asString.
		((sym = 'F') or:[(sym = 'G')]) ifTrue:[
			pen go: lineLength.
			].
	
		(sym = '+')  ifTrue:[ pen turn: angle].
		(sym = '-')  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
applyRule=
	"F":n -> [self rule] 
| symbols
! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/13/2014 19:06'!
example=
	"t":n <spaces (letter | digit)*>:all ->[{n. all}]! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:59'!
readRule=
	letter:n -> [n]
	| symbols
	! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:02'!
rule
	^'F-F++F-F'! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:24'!
start=
	"I:":i spaces <digit>:d ";" spaces 
	"F:":f spaces readRule*:a ";" spaces
	"G:":g spaces readRule*:b ";" spaces
	"LS:":s spaces readRule*:n -> [{d. {f. a}. {g.  b}.  n}]
	

! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:24'!
startOld=
	"I:":i spaces <digit>:d ";" spaces 
	"F:":f spaces readRule*:a ";" spaces
	"G:":g spaces readRule*:b ";" spaces
	"LS:":s spaces readRule*:n -> [{d. {f. (self stringFromCollection: a)}. {g. (self stringFromCollection: b)}. (self stringFromCollection: n)}]
	

! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/13/2014 20:42'!
stringFromCollection: aCol

	|str|
	str := ''.
	aCol do:[:each| str := str, each asString].
	^str! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
symbols=
	("-" | "+"):n -> [n] ! !

OMeta2 subclass: #LSystemGen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystemGen commentStamp: 'sn 9/15/2014 20:01' prior: 0!
LSystem matchAll: 'I: 2; F: F--F--F--G; G: GG; LS: F--F--F' with: #start. 
LSystemGen matchAll: {3. {$F. #($c $+ $F)}. #($F $G $- $G)} with: #testRule.


'F': 'F--F--F--G'  {$F. #($F $- $- $F $- $- $F $- $- $G)}

'G': 'GG'		{$G. #($G $G)}

'F--F--F'        #($F $- $- $F $- $- $F)

LSystemGen matchAll: {6. { {$F. #($F $- $- $F $- $- $F $- $- $G)}.  {$G. #($G $G)}}. #($F $- $- $F $- $- $F)} with: #testRule 
!

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:16'!
flatCollection: aCol
	
	^aCol gather:[:each| 
	each select:[:c| c isCharacter]
] ! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:59'!
line=
	(letter | symbols)*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:48'!
rules=
	{letter {line}}*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:49'!
symbols=
	($- | $+):n -> [n asCharacter]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:37'!
takeRule :g =
	{takeRule2(g)*:m} -> [self flatCollection: m ]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:54'!
takeRule2 :g =
	letter:k ?[k=g first first] -> [g first second]
| letter:k ?[k=g second first] -> [g second second]
| letter:k -> [{k}]
| symbols:n -> [{n asCharacter}]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:50'!
testRule 0 {rules} {line}:t = [t],
	testRule _:n _:g takeRule(g):k= testRule(n-1. g. k):m -> [m]! !
